/*---------------------------------------------------------------------------------
	Copyright 2013- j2jlab, Inc. All Rights Reserved.		by ODIN
---------------------------------------------------------------------------------*/
#define MAX_SCENE_COLOR		2
#define NUM_DOF_SAMPLES		4
#define NUM_DOF_ARRAYS		2 	//(NUM_DOF_SAMPLES/ 2)
#define INV_DOF_SAMPLES		(0.25)

uniform sampler2D UserTexture0;

uniform lowp float BloomScale;

varying highp vec4 finOffsetUVs[NUM_DOF_ARRAYS];

mediump vec4 GetFrameColorAndDepth(highp vec2 uv)
{
	 return texture2D(UserTexture0,uv); 
}

mediump vec4 GetFinalColor(mediump vec3  BloomColor, mediump vec3  SceneColor, mediump float SceneDepth)
{
//	mediump float UnfocusedPercent = GetUnfocusedRate(SceneDepth);
	mediump float UnfocusedPercent = 1.0;
	mediump vec3 UnfocusedColor = UnfocusedPercent * SceneColor;
	return vec4(UnfocusedColor + BloomColor,UnfocusedPercent);
}
#define _BLOOM_CMP	0.8

bool _any(mediump vec4 x)       // bvec can be bvec2, bvec3 or bvec4
{
    int i;
	if( x.r > _BLOOM_CMP )
	{
	    return true;
	}
	if( x.r > _BLOOM_CMP )
	{
	    return true;
	}
	if( x.b > _BLOOM_CMP )
	{
	    return true;
	}
    return false;
}
void main()
{
	mediump vec3 BloomColor = vec3(0); 
	mediump vec4 SceneColorAndDepth = vec4(0);

	for(int ChunkIndex = 0;ChunkIndex < NUM_DOF_SAMPLES / 2;ChunkIndex++)
	{
		mediump vec4 SceneColorAndDepth1 = GetFrameColorAndDepth(finOffsetUVs[ChunkIndex].xy);
		
		SceneColorAndDepth += SceneColorAndDepth1;
		if( _any(SceneColorAndDepth1) )
			BloomColor += SceneColorAndDepth1.rgb;

		mediump vec4 SceneColorAndDepth2 = GetFrameColorAndDepth(finOffsetUVs[ChunkIndex].wz);
		SceneColorAndDepth += SceneColorAndDepth2;

		if( _any(SceneColorAndDepth1) )
			BloomColor += SceneColorAndDepth2.rgb;
	}

	BloomColor = BloomColor * BloomScale * INV_DOF_SAMPLES;
	SceneColorAndDepth = SceneColorAndDepth * INV_DOF_SAMPLES;

	//bloom dof finally  normalize 0~1
	gl_FragColor = GetFinalColor(BloomColor, SceneColorAndDepth.rgb, SceneColorAndDepth.a) / (MAX_SCENE_COLOR);
//	gl_FragColor = SceneColorAndDepth/ (MAX_SCENE_COLOR);
}

