/*---------------------------------------------------------------------------------
	Copyright 2013~ j2jlab, Inc. All Rights Reserved.		by ODIN
---------------------------------------------------------------------------------*/
#define vSpecColor LightColor

attribute highp vec3  inVertex;
#ifdef _Gf_DIFFUSE_VERTEX_STRUCT			/* ؽ ü diffuse Ѵ.*/
attribute mediump vec4	inColor;
#endif
attribute highp vec3  inNormal;
#ifdef _Gf_USE_TANGENT_VERTEX_STRUCT		/* ؽ ü ָ ѱ  ִ.*/
attribute highp vec4  inTangent;
#endif
attribute mediump _uvvec  inTexCoord;

uniform highp vec3  EyePos;
uniform lowp vec3  LightDir;
uniform lowp vec3  LightColor;
/* uniform lowp vec3  LightAmbient; */

uniform highp vec4 FogPara;
#define FogStart	FogPara.r
#define FogEnd		FogPara.g
#define FogDensity	FogPara.b

uniform highp mat4  MVPMatrix;			// model view projection transformation
uniform highp mat4  MVMatrix;			// model view transformation
uniform highp mat4  MMatrix;			// model(world) matrix

varying mediump vec4	finColor;
varying mediump _uvvec  finTexCoord;

varying highp vec4		finViewVec;
varying mediump vec4	finTanDiffPos;	/* for Dynamic light */

varying highp vec3		finTanMat0;
varying highp vec3		finTanMat1;
varying highp vec3		finTanMat2;

varying highp vec3		finLocal;
varying lowp vec3		finNormal;
#define FogIntensity	finViewVec.w


void main()
{
	mediump vec3 WorldPos;
	mediump vec3 normal;
	mediump vec4 Color;
	highp vec4 position;
	mediump float NdotL;

#if defined(_Gf_USE_TANGENT_VERTEX_STRUCT) || defined(_Gf_PER_PIXEL_ATTN)
	Color=vec4(1,1,1,1);
#else
	#ifdef _Gf_UNLIT
		Color=vec4(1,1,1,1);
	#else
		Color=vec4(0,0,0,1);
	#endif
#endif

//	GetPosAndNormal(position,normal,inVertex,inNormal);

#ifdef _Gf_BLEND_VERTEX_STRUCT	
	mediump ivec4 boneIndex = ivec4(inBoneIndex);
	mediump vec2 boneWeights = vec2(inBoneWeights,1.0-inBoneWeights);

	int i_idx = int(inBoneIndex.x);
	position.xyz = MulBone4(vec4(inVertex,1.0),i_idx,boneWeights.x);
	normal = MulBone3(inNormal,i_idx,boneWeights.x);

	if(1 < BoneCount)
 	{
		i_idx = int(inBoneIndex.y);
 		position.xyz += MulBone4(vec4(inVertex,1.0),i_idx,boneWeights.y);
 		normal += MulBone3(inNormal,i_idx,boneWeights.y);
 	}

	normal = normalize(normal);
	position.w = 1.0;
#else
	position = vec4(inVertex, 1.0);
	normal = inNormal;
#endif


	normal = _VERTEX_NORMAL_COMPONENT;
	position = _VERTEX_POSITION_COMPONENT;
	normal = (MMatrix * vec4(normal,0)).xyz;
	WorldPos = (MMatrix*position).xyz;

#ifdef _Gf_PER_PIXEL_ATTN
	finLocal = WorldPos;
#endif

#ifdef _Gf_USE_VIEW_VEC
	highp vec4 wpos = MMatrix * position;
	finViewVec.xyz = normalize(EyePos - wpos.xyz);
#endif

	gl_Position = MVPMatrix * position;



#ifdef _Gf_USE_TANGENT_VERTEX_STRUCT
	highp vec3 bitangent = cross(normal, inTangent.xyz)*inTangent.w;
	finTanMat0 = inTangent.xyz;
	finTanMat1 = bitangent;
	finTanMat2 = normal;

	//߰Ʈ
	{
		finTanDiffPos.xyz=(AddLightPos.xyz - WorldPos);
	#ifndef _Gf_PER_PIXEL_ATTN
		finTanDiffPos.w = GetAttnFromLight(finTanDiffPos.xyz,_GetAddLightAttnStart,_GetAddLightAttnEnd);
	#endif
	}

	#ifndef _Gf_USE_NORMAL_MAP
		finNormal = normal;
	#endif

#else	//_Gf_BLEND_VERTEX_STRUCT

//	#ifdef _Gf_PER_PIXEL_ATTN 
	finNormal = normal;
//	#endif

	#ifndef _Gf_PER_PIXEL_ATTN 
		#ifndef _Gf_UNLIT
			NdotL = dot(normal,LightDir);

			#ifdef _GF_HALFLAMBERT
				NdotL = max( dot(LightDir, normal)*0.2+ 0.5, 0.0);
			#endif
			
			if (NdotL > 0.0) 
			{
				Color.rgb += LightColor*NdotL;
			}
		
			//߰Ʈ
			{
				mediump vec3 LightDiffPos = (AddLightPos.xyz - WorldPos);
				NdotL = dot( normal, normalize(LightDiffPos) );

				#ifdef _GF_HALFLAMBERT
					NdotL = max( dot(normalize(LightDiffPos), normal)*0.2+ 0.5, 0.0);
				#endif
				
				if (NdotL > 0.0)
				{
					NdotL *= GetAttnFromLight(LightDiffPos,_GetAddLightAttnStart,_GetAddLightAttnEnd);
					Color.rgb += AddLightColor.rgb*NdotL;
				}
			}
		#endif	//_Gf_UNLIT
	#endif
#endif	//NO_TANGENT

//#ifdef _Gf_UNLIT
	//Color.rgb *= 2.0;
//#endif

#ifdef _Gf_DIFFUSE_VERTEX_STRUCT	/* diffuse. */
	Color = Color*inColor;
#endif
	finColor = Color;

	finTexCoord = inTexCoord;

#ifndef _Gf_UNLIT
	//------------ װ.
 	highp vec3 viewPos = vec3(MVMatrix * position);
	FogIntensity = viewPos.z;
#endif
}

