#define tex2D texture2D

#ifdef _Gf_USE_TEXCOORD_2		/*ؽǥ2*/
#define _uvvec vec4
#else
#define _uvvec vec2
#endif

//uniform mediump float vBias;
#define vBias	-1.0


mediump vec3 BiasNormalMap( mediump vec4 Normal )
{
	return Normal.rgb * 2.0 - 1.0;
}
#ifdef _GAMMA_CORRECTION
#define _GAMMA_CONSTANT	2.2		

lowp vec3 GammaCorrect( lowp vec4 Color )
{
	return ( pow( Color.xyz, _GAMMA_CONSTANT));
}
lowp vec3 InvGammaCorrect( lowp vec4 Color )
{
	return ( pow( Color.xyz, 1.0f/_GAMMA_CONSTANT ));
}
#else
lowp vec3 GammaCorrect( lowp vec4 Color )
{
	return Color.rgb;
}
lowp vec3 InvGammaCorrect( lowp vec4 Color )
{
	return Color.rgb;
}
#endif



//-̳ Ʈ . 
//uniform lowp int AddLightNum;
uniform mediump vec4 AddLightColor;
uniform mediump vec4 AddLightPos;
#define _GetAddLightAttnStart		AddLightColor.w
#define _GetAddLightAttnEnd			AddLightPos.w

mediump float GetAttnFromLight(mediump vec3 lightPosWS,mediump float attn_start,mediump float attn_end)
{
	mediump float att_inten;

	mediump float sq = sqrt(dot(lightPosWS,lightPosWS));
	att_inten = 1.0-(sq-attn_start)/(attn_end-attn_start);		/* attn ȿ ִ. */
	return clamp(att_inten,0.0, 1.0);
}

lowp float GetNdotL(mediump  vec3 LightDir,mediump  vec3 normal)
{
	lowp float NdotL;
#ifdef _GF_HALFLAMBERT
	NdotL = max( dot(LightDir, normal)*0.3+ 0.9, 0.0);
#else
	NdotL = max( dot(LightDir, normal) , 0.0);
#endif
	return NdotL;
}

mediump vec3 GetReflectionVector(mediump vec4 eye,mediump vec3 normal)
{
#if _Gf_SHADER_LOD < 3
	return (dot(normal,eye.xyz) * 2.0 * normal - eye.xyz);
#else
	return vec3(0.0,1.0,0.0);
#endif
}

mediump vec3 GetCubeUV(mediump vec3 eye,mediump vec3 normal)
{
//	return reflect(eye,normal);
	return (dot(normal,eye) * 2.0 * normal-eye);
}

mediump float GetFresnelTerm(mediump  vec3 eyeVector,mediump  vec3 normal,mediump float power)
{
    mediump float fresnelTerm;
	fresnelTerm = 1.0-dot(eyeVector, normal);
	fresnelTerm = pow(fresnelTerm,power);
    return fresnelTerm;
}

lowp vec4 GetMaskColorValue(lowp vec4 diff,lowp vec4 mask,lowp vec4 grey,lowp vec3 SkinColor)
{
	return ( 1.0- mask ) * diff + ( mask * grey * vec4(SkinColor,1) );
}

lowp vec4 GetMaskReflection(lowp vec4 diff, sampler2D ref_tex,highp vec2 ref_uv,lowp vec4 mask,lowp float WaterAlpha, lowp vec4 AlphaChannel)
{
	lowp vec4 refl = tex2D( ref_tex, ref_uv ,vBias );
	return mix( diff, refl * WaterAlpha + ( 1.0 - WaterAlpha ) * diff, dot( mask, AlphaChannel));
}

lowp vec4 GetSplatting4(sampler2D diff_tex_1, sampler2D diff_tex_2, sampler2D mul_tex, sampler2D alpha_tex, sampler2D diff_tex_3, sampler2D diff_tex_4,highp vec4 uv , lowp vec4 AlphaChannel, lowp vec4 AlphaChannel_2, lowp vec4 AlphaChannel_3)
{
	lowp vec4 diff = tex2D( diff_tex_1,uv.xy, vBias );
	lowp vec4 diff2 = tex2D( diff_tex_2,uv.xy, vBias );
	lowp vec4 mul = tex2D( mul_tex,uv.zw, vBias );
	lowp vec4 alpha = tex2D( alpha_tex,uv.zw, vBias );
	lowp vec4 diff3 = tex2D( diff_tex_3,uv.xy, vBias );
	lowp vec4 diff4 = tex2D( diff_tex_4,uv.xy, vBias );
	
	lowp vec4 mix_a = mix( diff, diff2, dot( alpha, AlphaChannel ));
	lowp vec4 mix_b = mix(mix_a, diff3, dot( alpha, AlphaChannel_2 ));
	return ( mul * 2.0 ) * mix(mix_b, diff4, dot( alpha, AlphaChannel_3 ));
}

lowp vec4 GetSplatting3(sampler2D diff_tex_1, sampler2D diff_tex_2, sampler2D mul_tex, sampler2D alpha_tex, sampler2D diff_tex_3, highp vec4 uv , lowp vec4 AlphaChannel, lowp vec4 AlphaChannel_2)
{
	lowp vec4 diff = tex2D( diff_tex_1,uv.xy, vBias );
	lowp vec4 diff2 = tex2D( diff_tex_2,uv.xy, vBias );
	lowp vec4 mul = tex2D( mul_tex,uv.zw, vBias );
	lowp vec4 alpha = tex2D( alpha_tex,uv.zw, vBias );
	lowp vec4 diff3 = tex2D( diff_tex_3,uv.xy, vBias );
	
	lowp vec4 mix_a = mix( diff, diff2, dot( alpha, AlphaChannel ));
	lowp vec4 mix_b = mix(mix_a, diff3, dot( alpha, AlphaChannel_2 ));
	return ( mul * 2.0 ) * mix_b;
}

lowp vec4 GetShallowWater(sampler2D diff_tex, sampler2D nor_tex, sampler2D ref_tex, highp vec2 ref_uv, highp vec4 uv, lowp float WaterAlpha, mediump vec2 UVScroll)
{
	lowp vec4 diff = tex2D( diff_tex, (uv.xy + (nor_tex, (uv.xy * 2.0 + UVScroll).xy * 0.2)), vBias );
	lowp vec4 refl = tex2D( ref_tex, ref_uv ,vBias );
	
	return (refl * WaterAlpha ) + (( 1.0 - WaterAlpha ) * diff);
}

lowp vec4 GetLightmapShallowWater(sampler2D diff_tex, sampler2D nor_tex, sampler2D ref_tex, highp vec2 ref_uv, highp vec4 uv, lowp float WaterAlpha, mediump vec2 UVScroll)
{
	lowp vec4 diff = tex2D( diff_tex, (uv.xy + (nor_tex, (uv.xy * 2.0 + UVScroll).xy * 0.2)), vBias );
	lowp vec4 refl = tex2D( ref_tex, ref_uv ,vBias );
	
	return (refl * WaterAlpha ) + (( 1.0 - WaterAlpha ) * diff);
}

uniform sampler2D TableTex0;
lowp vec3 GetNdotLTable(lowp float NdotL)
{
	return tex2D(TableTex0,vec2(NdotL,0.5)).rgb;
}

lowp vec3 GetLobbyWater(sampler2D nor_tex_1, sampler2D nor_tex_2, highp vec2 uv, highp vec2 uv_scroll, highp vec2 uv_scroll_2, highp vec2 uv_scroll_3, highp vec2 uv_scroll_4)
{
	highp vec4 nor_1,nor_2,nor_3,nor_4,nor_5;
	nor_1.xyz = ( BiasNormalMap(tex2D( nor_tex_1, uv*vec2(0.01,0.01),vBias )) * 1.0 );
	nor_2.xyz = tex2D( nor_tex_2, ( (( uv*vec2(2.5,2.5) + uv_scroll )) + nor_1.xy ),vBias ).xyz;
	nor_3.xyz = BiasNormalMap(tex2D( nor_tex_2, ( uv*vec2(5,5) + uv_scroll_2 ),vBias ));
	nor_4.xyz = BiasNormalMap(tex2D( nor_tex_2, ( uv*vec2(5,5) + uv_scroll_3 ),vBias ));
	nor_5.xyz = BiasNormalMap(tex2D( nor_tex_2, ( uv*vec2(7,7) + uv_scroll_4),vBias ) );
	
	nor_5.xyz = ( ( BiasNormalMap(nor_2) + nor_3.xyz ) + ( nor_4.xyz + nor_5.xyz) );
	highp vec3 ret;
	ret.x = pow( nor_5.x , 2.0 );
	ret.y = pow( nor_5.y , 2.0 );
	ret.z = pow( nor_5.z , 2.0 );
	return ret;
}

lowp vec4 GetMaskCube(sampler2D diff_tex, sampler2D mask_tex, lowp vec4 cube, highp vec4 uv, lowp float WaterAlpha, lowp vec4 AlphaChannel)
{
	lowp vec4 diff = tex2D( diff_tex, uv.xy, vBias );
	lowp vec4 mask = tex2D( mask_tex, uv.xy, vBias );
	
	return mix( diff, (diff * diff) + (cube * WaterAlpha) , dot( mask, AlphaChannel));
}

lowp vec4 GetLSpecPixelReflection(sampler2D diff_tex, sampler2D ref_tex, highp vec4 uv, highp vec4 view_vec,mediump vec3 normal, lowp float WaterAlpha)
{
	lowp vec4 refl=vec4(0);
	lowp vec4 diff=vec4(0);
	diff = tex2D( diff_tex, uv.xy,vBias );

#if _Gf_SHADER_LOD < 3
	refl = tex2D( ref_tex, GetReflectionVector(view_vec,normal).xz,vBias ) * WaterAlpha; 
	diff *= ( 1.0 - WaterAlpha);
#endif
	return diff + refl;
}












