/*---------------------------------------------------------------------------------
	Copyright 2013~ j2jlab, Inc. All Rights Reserved.		by ODIN
---------------------------------------------------------------------------------*/
#define MAX_SCENE_COLOR		2.0

uniform sampler2D UserTexture0;		//frame
uniform sampler2D UserTexture1;		//dof

varying mediump vec2 finTexCoord;

mediump vec4 GetFrameColorAndDepth(highp vec2 uv)
{
	 return texture2D(UserTexture0,uv); 
}

void main()
{
	//Ŀ ϰ
	highp vec2 UV = finTexCoord;
	highp vec4 FocusedSceneColorAndDepth = GetFrameColorAndDepth(UV);
	highp vec3 vColor;

	vColor = FocusedSceneColorAndDepth.rgb;

//#ifdef _USE_DOF
	//--------------------------- DOF Ŀ ϰ.
//	lowp float  FocusedRate = GetFocusedRate(FocusedSceneColorAndDepth.a);
	lowp float  FocusedRate = 0.5;

	// 0~1 ÷ ...
	highp vec4 UnfocusedSceneColorAndRate = MAX_SCENE_COLOR * texture2D(UserTexture1,UV);
	vColor = (vColor * FocusedRate + UnfocusedSceneColorAndRate.rgb) / (FocusedRate + UnfocusedSceneColorAndRate.a);
//#endif


#ifdef _USE_TONE_MAPPING_TYPE
	vColor.rgb = _npow(vColor.rgb, 1.0f / 2.2f) * sign(vColor.rgb);
#endif

#ifdef _USE_DESATURATION
	highp float grayscale = dot(float3(0.222f,0.707,0.071),vColor.rgb);
	vColor.rgb = Desaturation*grayscale + (1-Desaturation)*vColor.rgb;
#endif

#ifdef _USE_COLOR_LEVEL	// ÷
	//÷Ʈ..Level .  ƿǲ. 
	vColor.rgb = (_npow(saturate((vColor.rgb-inBlack.rgb))/(inWhite.rgb - inBlack.rgb),Gamma)*(outWhite.rgb - outBlack.rgb) + outBlack.rgb).rgb;
	vColor.rgb = (_npow(saturate((vColor.rgb-inBlackRGB))/(inWhiteRGB - inBlackRGB),GammaRGB)*(outWhiteRGB - outBlackRGB) + outBlackRGB).rgb;
	highp vec3 MaterialResult = GammaColor.rgb + vColor;
	//------------------------------- .
	highp vec3 LinearColor = MaterialResult.rgb * GammaColorScale.rgb;
	vColor.rgb = _npow(saturate(LinearColor), GammaInverse);
#endif

	gl_FragColor = vec4( vColor, 1.0 );
}
