/*---------------------------------------------------------------------------------
	Copyright 2013- j2jlab, Inc. All Rights Reserved.		by ODIN
---------------------------------------------------------------------------------*/
#define NUM_SAMPLES		4
#define NUM_ARRAYS		(NUM_SAMPLES/ 2)
#define INV_SAMPLES		(0.16) //(0.25/1.5)

uniform sampler2D UserTexture0;

varying highp vec4 finOffsetUVs[NUM_ARRAYS];

mediump vec4 GetFrameColorAndDepth(highp vec2 uv)
{
	 return texture2D(UserTexture0,uv); 
}

void main()
{
	mediump vec3 BloomColor = vec3(0); 
	mediump vec4 SceneColorAndDepth = vec4(0);

	for(int ChunkIndex = 0;ChunkIndex < NUM_SAMPLES / 2;ChunkIndex++)
	{
		mediump vec4 SceneColorAndDepth1 = GetFrameColorAndDepth(finOffsetUVs[ChunkIndex].xy);
		SceneColorAndDepth += SceneColorAndDepth1;

		mediump vec4 SceneColorAndDepth2 = GetFrameColorAndDepth(finOffsetUVs[ChunkIndex].wz);
		SceneColorAndDepth += SceneColorAndDepth2;

	}
	gl_FragColor = SceneColorAndDepth * INV_SAMPLES;
}

