/*---------------------------------------------------------------------------------
	Copyright 2013~ j2jlab, Inc. All Rights Reserved.		by ODIN
---------------------------------------------------------------------------------*/


attribute mediump vec4 inBoneIndex;
attribute mediump float inBoneWeights;

#define _Gf_MAX_BONE_CNT	50

uniform mediump	int	 BoneCount;
uniform highp   mat3 BoneMatrixArray[_Gf_MAX_BONE_CNT];
uniform highp   vec3 BoneMatrixArray3[_Gf_MAX_BONE_CNT];

highp vec3 MulBone4( highp vec4 vInputPos, highp int nMatrix,highp float fBlendWeight )
{
	highp vec3 vResult;
	vResult = BoneMatrixArray[nMatrix] * vInputPos.xyz;
	vResult += BoneMatrixArray3[nMatrix];
	return vResult * fBlendWeight;
}

attribute highp vec3  inVertex;
uniform highp mat4  MVPMatrix;			

void main()
{
	highp vec4 position;

	mediump ivec4 boneIndex = ivec4(inBoneIndex);
	mediump vec2 boneWeights = vec2(inBoneWeights,1.0-inBoneWeights);

	int i_idx = int(inBoneIndex.x);
	position.xyz = MulBone4(vec4(inVertex,1.0),i_idx,boneWeights.x);

	if(1 < BoneCount)
 	{
		i_idx = int(inBoneIndex.y);
 		position.xyz += MulBone4(vec4(inVertex,1.0),i_idx,boneWeights.y);
 	}
	position.w = 1.0;
	gl_Position = MVPMatrix * position;
}
